
/* HardDiskNew.h - New VDI API (Header)
 *
 * Copyright (c) 2008 Topalis AG
 * Author: Christian Kellner <christian.kellner@topalis.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <VBox/VBoxHDD-new.h>

#include <string>
#include <exception>

#include "HardDisk.h"
#include "IOError.h"

#ifndef __HARD_DRIVE_NEW
#define __HARD_DRIVE_NEW 1


class HardDiskNew : public HardDisk {

public:

    HardDiskNew ();
    virtual ~HardDiskNew ();

    virtual void     OpenImage  (std::string path, unsigned int flags = VD_OPEN_FLAGS_NORMAL);
    virtual void     Read       (uint64_t offset, void *data, size_t len);
    virtual void     Write      (uint64_t offset, const void *data, size_t len);
    virtual void     Close      ();
    virtual uint64_t GetSize    ();
    virtual bool     IsReadOnly ();
    virtual const char *GetFormat ();
    virtual unsigned int DefaultOpenFlags () { return VD_IMAGE_FLAGS_DEFAULT; };

private:
    int Initilize ();

private:
    PVDINTERFACE     vdIfs;
    VDINTERFACE      vdInterfaceError;
    VDINTERFACEERROR vdInterfaceErrorCallbacks;

    /*  */

    /* The real thing */
    PVBOXHDD      diskHandle;
    unsigned int  nImages;
    char         *format;
};

#endif

