
/* HardDiskOld.h - HardDisk API OLD (header)
 *
 * Copyright (c) 2008 Topalis AG
 * Author: Christian Kellner <christian.kellner@topalis.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <string>
#include <exception>

#include <VBox/VBoxHDD.h>

#include "HardDisk.h"

#ifndef __HARD_DRIVE_OLD
#define __HARD_DRIVE_OLD 1

class HardDiskOld : public HardDisk {

public:

    HardDiskOld ();
    virtual ~HardDiskOld ();

    virtual void     OpenImage  (std::string path, unsigned int flags);
    virtual void     Read       (uint64_t offset, void *data, size_t len);
    virtual void     Write      (uint64_t offset, const void *data, size_t len);
    virtual void     Close      ();
    virtual uint64_t GetSize    ();
    virtual bool     IsReadOnly ();
    virtual const char *GetFormat ();
    virtual unsigned int DefaultOpenFlags () { return VDI_OPEN_FLAGS_NORMAL; }

private:
    void Initilize ();

private:

    /* The real thing */
    PVDIDISK      diskHandle;
    unsigned int  nImages;
};

#endif


