
/* Socket.h - Socket Abstraction Class (Header)
 *
 * Copyright (c) 2008 Topalis AG
 * Author: Christian Kellner <christian.kellner@topalis.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#ifndef SOCKET_H
#define SOCKET_H

#include "Buffer.h"

class Socket {

public:
    Socket (int sock_fd = -1)
        : timeout (0) {
        this->sock = sock_fd;
    }

    Socket & operator= (int sock_fd) {
        this->sock = sock_fd;
        return *this;
    }

    ssize_t  Read  (void *buf, size_t count);
    ssize_t  Write (const void *buf, size_t count);

    Buffer * Read  (size_t count);
    void     Write (Buffer* const buffer);

    int Close ();
    void SetTimeOut (int secs);

private:
    int      Wait  (bool read);

private:
    int timeout;
    int sock;
};

#endif
