

#include "UUID.h"

const UUID UUID::Null = UUID (false);


UUID::UUID (bool generateNew)
{
    if (generateNew)
        RTUuidCreate (&uuid);
    else
        RTUuidClear (&uuid);
}

UUID::UUID (const RTUUID &id)
    : uuid (id)
{

}

bool
UUID::IsNull () const
{
    return RTUuidIsNull (&uuid);
}

void
UUID::Clear ()
{
    RTUuidClear (&uuid);
}


std::string
UUID::ToString () const
{
    char buffer[RTUUID_STR_LENGTH];

    RTUuidToStr (&uuid, buffer, sizeof (buffer));

    return std::string (buffer);
}

bool
UUID::operator< (const UUID &compare) const
{
    return RTUuidCompare (&uuid, &(compare.uuid)) < 0;
}

bool
UUID::operator== (const UUID &compare) const
{
    return RTUuidCompare (&uuid, &(compare.uuid)) == 0;
}

std::ostream&
operator << (std::ostream& os, UUID const & uuid)
{
    os << uuid.ToString ();

    return os;
}
