
/* UUID.h - RTUUID Abstraction class (Header)
 *
 * Copyright (c) 2008 Topalis AG
 * Author: Christian Kellner <christian.kellner@topalis.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <iprt/uuid.h>

#include <ostream>

#ifndef UUID_H
#define UUID_H

class UUID {

public:

    UUID (bool generateNew = true);
    UUID (const RTUUID &id);

    bool IsNull () const;
    void Clear ();

    bool operator< (const UUID &compare) const;
    bool operator== (const UUID &compare) const;

    std::string ToString () const;

    static const UUID Null;

private:
    RTUUID uuid;
};

std::ostream& operator << (std::ostream&, UUID const &);


#endif

