
/* HardDisk.cpp - HardDisk API Abstraction Class
 *
 * Copyright (c) 2008 Topalis AG
 * Author: Christian Kellner <christian.kellner@topalis.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <cstdio>

#include "VBoxFailure.h"

VBoxFailure::VBoxFailure (int vrc)
    : vrc (vrc)
{

}

const char *
VBoxFailure::what () const throw ()
{
    snprintf ((char *) errorString, sizeof (errorString), "%s [%d]",
              RTErrGetFull (vrc), vrc);


    return errorString;
}

