
/* VBoxHddTree.cpp - Take a list of vdi and try to try to create
 * the correct family tree
 *
 * Copyright (c) 2008 Topalis AG
 * Author: Christian Kellner <christian.kellner@topalis.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include "Log.h"

#include <getopt.h>

#include <cstdarg>
#include <cstdlib>

#include <string>
#include <vector>
#include <map>
#include <list>
#include <exception>

#include <iostream>

#include "UUID.h"
#include "VBoxFailure.h"

#include "HardDisk.h"

int
main (int argc, char **argv)
{
    std::list<std::string> pathList;

    for (int i = 1; i < argc; i++) {
        std::string curPath = argv[i];
        pathList.push_back (curPath);
    }

    std::list<std::string> sorted = HardDisk::SortFamily (pathList);

    std::list<std::string>::iterator iter;
    for (iter = sorted.begin (); iter != sorted.end (); iter++) {
        std::cout << *iter << " ";
    }


    return EXIT_SUCCESS;
}

